/*______________________________________________________________________________________
 *
 *       Author : Pascal Vincent
 *                LPNHE IN2P3-CNRS-Universite Paris VI & VII
 *                   4, Place Jussieu - BP 200 - Tour 33 Rdc
 *                             75252 PARIS cedex 05 - France
 *
 *       All comment and Remarks are Welcome
 *                         vincentp@in2p3.fr  
 *
 * This include describe the output format of the data comming from the camera :
 * 
 *    fDrawer/fCarteId  Identificator of a drawer or a carte depending of the message
 *    
 *        + fData
 *
 * In addition to this information all message is encapsulated by :
 *  - Header : 0xAAAA
 *  - Message identificator (0xFFnn = Slow control)
 *
 *      (messages)
 *
 *  - Tailer : 0xAAAA
 *______________________________________________________________________________________
 */
#ifndef SDAQCONTROL_H
#define SDAQCONTROL_H

#include "HESSDAQDefine.h"

struct ControlScale
{
    short fDrawerId;
    short fScale[__NUMBER_OF_PMT_IN_DRAWER];
    short fDCI  [__NUMBER_OF_PMT_IN_DRAWER];
};

struct ControlMonitoring
{
    short fDrawerId;

    short bHTStatus;
    short fHTVMon[__NUMBER_OF_PMT_IN_DRAWER];
    short fHTIMon[__NUMBER_OF_PMT_IN_DRAWER];
    short fTemperature[__NUMBER_OF_THERMOMETERS];
};

typedef struct ControlSlow
{
  short fHeader;
  short fMessageId;
  short fDrawerId;

  short fHT[__NUMBER_OF_PMT_IN_DRAWER];
  short fTriggerThreshold;
  short fTailer;
} CNTRLSc;

typedef struct ControlHT
{
  short fHeader;
  short fMessageId;
  short fDrawerId;
  
  short bHTCommand;
  short fTailer;
} CNTRLHt;

typedef struct ControlTG
{
  short fHeader;
  short fMessageId;
  short fDrawerId;
  
  short bTGCommand;
  short fTailer;
} CNTRLTg;

typedef struct ControlDAQ
{
  short fHeader;
  short fMessageId;
  short fDrawerId;

  short bAutoOffBoardEventType;
  short bScalerWindow;
  unsigned short bDelayOfChargeOrSamplingAndWidth;
  short fTailer;
} CNTRLDaq;

typedef struct {
  CNTRLSc  ctrls;
  CNTRLHt  ctrlh;
  CNTRLTg  ctrlt;
  CNTRLDaq ctrld;
} Slc_config;

#endif
