#ifndef SDAQDEFINE_H
#define SDAQDEFINE_H
/*______________________________________________________________________________________
 *
 *       Author : Pascal Vincent
 *                LPNHE IN2P3-CNRS-Universite Paris VI & VII
 *                   4, Place Jussieu - BP 200 - Tour 33 Rdc
 *                             75252 PARIS cedex 05 - France
 *
 *       All comment and Remarks are Welcome
 *
 *                         vincentp@in2p3.fr  
 *
 * General parameters of a single camera (define Drawer and Carte paramters)
 *______________________________________________________________________________________
 */
 
#define __EVENT_HEADER 0xEEEE
#define __EVENT_TAILER 0xEFEF

#define __BLOCK_HEADER 0xAAAA
#define __BLOCK_TAILER 0xAAAA

/* Carte parameters  */
#define __NUMBER_OF_MEMORIES_IN_CARTE  4
#define __NUMBER_OF_PMT_IN_CARTE 8
#define __NUMBER_OF_CHANNELS_IN_MERORY 4
#define __NUMBER_OF_SAMPLES_IN_MEMORY 16
#define __NUMBER_OF_GAIN 2

/* Drawer parameters */
#define __NUMBER_OF_PMT_IN_DRAWER 16
#define __NUMBER_OF_CARTE_IN_DRAWER 2
#define __NUMBER_OF_DRAWER 60

/* Temperture parameter */
#define __NUMBER_OF_THERMOMETERS  8

/* DAQ message identificators */
#define __DAQ_SAMPLE 0xFF01
#define __DAQ_CHARGE 0xFF02

/* Slow Control message identificators */
#define __CONTROL_DUMMY      0xFF00
#define __CONTROL_HT         0xFF0A
#define __CONTROL_SLOW       0xFF0B
#define __CONTROL_MONITORING 0xFF0C
#define __CONTROL_TG         0xFF0D
#define __CONTROL_SCALE      0xFF0E
#define __CONTROL_DAQ        0xFF10

/* Trigger definition */
#define __TRIGGER_PEDESTAL 0
#define __TRIGGER_PHYSICAL 1

#endif
