/************************************************************************
 *
 * Read the register Photodiode value of slowControl interface 
 *  
 * Author : Jean-Luc PANAZOL
 *          LAPP-ANNECY
 * e-mail : panazol@lapp.in2p3.fr 
 * Date   : oct 2007
 * Input :
 *   - File descriptor
 * Output :
 *   - Photodiode value
 ************************************************************************
 * 
 cPCI_Photodiode_Value_Read
 
 */

#include <stdio.h>
#include <string.h>
#include <sys/ioctl.h>

#include "cpu_def.h"
#include "ctrlsecurity_def.h"    
#include "CtrlSecurityPilot.h"

int cPCI_Photodiode_Value_Read(int file_desc,int*r)
{
  int wc;

  wc = ioctl(file_desc, READ_PHOTODIODE_VALUE);
  *r=wc;
  printf("Photodiode value : %x\n",wc);
  return(wc);
};



