/************************************************************************
 *
 * Read the register Temperature MUX Channel Value of slowControl interface 
 *  
 * Author : Jean-Luc PANAZOL
 *          LAPP-ANNECY
 * e-mail : panazol@lapp.in2p3.fr 
 * Date   : oct 2007
 * Input :
 *   - File descriptor
 * Output :
 *   - Temperature MUX Channel Value
 ************************************************************************
 * 
 cPCI_Temp_MUX_VALUE_Read
 
 */

#include <stdio.h>
#include <string.h>
#include <sys/ioctl.h>

#include "cpu_def.h"
#include "ctrlsecurity_def.h"    
#include "CtrlSecurityPilot.h"

int cPCI_Temp_MUX_VALUE_Read(int file_desc,float *t)
{
  int wc;

  wc = ioctl(file_desc, READ_TEMP_MUX_VALUE);
 // printf("Temperature test MUX channel Value: %x = %2.2f C\n",wc,((wc-22.983)/2.8682));
  *t = (wc-22.983)/2.8682;
 // printf("wc=%d, *t=%d\n",wc,*t);
  return(wc);
};



