#include "my.h"

#include "HESSDAQDefine.h"
#include "HESSDAQControl.h"
#include "cpu_def.h"    
#include "ctrlsecurity_def.h"     

#define __MAIN__
#include "CtrlSecurityPilot.h"
#undef __MAIN__

/* configure variable global */
int   fin=1;
int   tempOnOff =0;
int   photodiodeOnOff=0;
int   tempNbMoy =0;
int   photodiodeNbMoy =0;
float seuilTemp[MAX_SEUIL];
float seuilTempDecrease[MAX_SEUIL];
float seuilPhotodiodeIncrease[10];
float seuilPhotodiodeDecrease[10];
int   nbSeuilTemp=5;
int   nbSeuilPhotodiode=3;
int   etat[NB_SENSOR];
int   etatPhotoDiode[NB_PHOTODIODE];
int   etatMax;
int   numSonde;
float moyTemp[NB_SENSOR][MAX_SEUIL];   
int   autoMod;
int   fanOutOnOff=0;
int   directionGPIO[NB_GPIO];
unsigned int ValueOutGPIO[NB_GPIO];
unsigned int ValueInGPIO[NB_GPIO];
char  descriptionGPIO[NB_GPIO][80];
int   client_socket;
int   client_socketMessage=-1;
float valeurMoyTemp[NB_SENSOR];
int   valeurLuFan[NB_FAN];
int*** tempFanTable;
int   calculFan[NB_FAN];
// arret du serveur
int   globale = 0;
char  alerteMessage[SIZE_BUFFER];
unsigned int seuilGPOLocateTable[MAX_SEUIL];
int   maskGPOLocateTable[MAX_SEUIL];
unsigned int seuilInOutGPOLocateTable0[NB_GPIO];
int   maskInOutGPOLocateTable0[NB_GPIO];
unsigned int seuilInOutGPOLocateTable1[NB_GPIO];
int   maskInOutGPOLocateTable1[NB_GPIO];
char  buffer[SIZE_BUFFER];
int   ma_socket;
int   ma_socketMessage;
char  caseString[NB_CASE][SIZE_STRING];
char  caseStringCmd[NB_CASE_CMD][SIZE_STRING];


char levelMessageTemp[MAX_SEUIL][20];
char levelMessagePhotodiode[MAX_SEUIL][20];
char levelMessageGPIO[20];

 Sem_et_int ind;
 Sem_et_int indMessage;
 sem_t semaphore_i;


// declaration des fonctions
 void * threadGPIO(void *pointStruc);
 void * threadTemperature(void *pointStruc);
 void * threadFan(void *pointStruc); 
 void * threadPhotodiode(void *pointStruc);  
 void * fils(void *pointStruc);
 int    appli(int no_client_socket);
 int    InitSocketServeur(Sem_et_int ind);
 int    InitSocketServeurMessage(Sem_et_int ind);
 int    parse2(char *bloc,int debut);
 int    initServeur(void);
 int    releaseServeur(void);

       
int initServeur(void) {
/** Description : Initialise le programme serveur */
/** Valeur de retour : 
	0 = ok
	1 = pb
*/ 
/** detail de la fonction :  */

	int cpt,cpt2;

	/** initCaseString() */
	if(initCaseString()==-1) {
		printf("pb with init() procedure\n");
		return(1);
	};

	/** initialisation des variables etat[], etatPhotoDiode[],etatMax, tempFanTable */
	for(cpt=0; cpt<NB_SENSOR; cpt++) {
           etat[cpt] = 0;         
	}

	for(cpt=0; cpt<NB_PHOTODIODE; cpt++) {
           etatPhotoDiode[cpt] = 0;         
	}
	etatMax=0;

	tempFanTable = (int ***)malloc(sizeof(int**) * NB_SENSOR ); //premire dimension
	for (cpt=0;cpt<NB_SENSOR;cpt++) {
		tempFanTable[cpt] =(int**) malloc(sizeof(int *)*MAX_SEUIL );
		for (cpt2=0;cpt2<MAX_SEUIL;cpt2++)
			tempFanTable[cpt][cpt2] = (int *) malloc(sizeof(int )*NB_FAN ); // 3 dimension
	}

	/** readConfigFile() */
	if(readConfigFile("defaut.txt")==-1){
		printf("pb with the configuration file : default.txt\n");
		return(1);
	};

	/** ouverture du device file (driver) */
	if ((file_desc = open(FAN_DEVICE_NAME, O_RDWR)) < 0) {
		printf ("pb :Can't open device file: %s\n",FAN_DEVICE_NAME);
		return(1);
	}

	/** InitSocketServeur() */
	 if (InitSocketServeur(ind)==-1) {
		 return(1);;
	 }
	 /** InitSocketServeurMessage()  */
	 if (InitSocketServeurMessage(indMessage)==-1) {
	 	 return(1);
	}

	/** init des semaphores */
	if (sem_init(&(semaphore_i), 0, 1) == -1) {
	    printf("Pb creation of semaphore.\n");
	    return(1);
	}

	ind.valAdd = 2;
	ind.sem = &semaphore_i;
	sem_trywait(ind.sem);
 
	indMessage.valAdd = 2;	
	indMessage.sem = &semaphore_i;
	sem_trywait(indMessage.sem);

	 return(0);
}

int releaseServeur(void) {
/** Description : Prepare le fin du programme  */
/** Valeur de retour : */
/**  -> 0 = ok */
/**	 -> 1 = pb */ 
/** detail de la fonction : */	
 
/** destruction des semaphores */
 if (sem_destroy(&(semaphore_i)) == -1) {
	printf("pb : detroy semaphore.\n");
    return(1);
 }

 /** appel fonction finPrg() */
 finPrg();
 return(0);
 }

int  main ( void ) {
/** Description : point d'entree du programme serveur */
/** detail de la fonction */	

 
 pthread_t thr[5]; 
 
/** initialisation du programme serveur :  initServeur()*/
 if(initServeur()) {
	exit(1);
 };

 
 /**  creation des threads */
 /** 
threadTemperature()
threadGPIO()
threadFan()
threadPhotodiode()
fils()*/
 pthread_create(&thr[0], NULL, threadTemperature,(void *) &ind);
 pthread_create(&thr[2], NULL, threadGPIO,(void *) &ind);
 pthread_create(&thr[3], NULL, threadFan,(void *) &ind);
 pthread_create(&thr[4], NULL, threadPhotodiode,(void *) &ind);
 pthread_create(&thr[1], NULL, fils,(void *) &ind);

 /** boucle infini tant que variable globale !=2*/
 while(globale !=2) {
      sleep(1);
 }

 /** releaseServeur() */
 if(releaseServeur()) {
	 exit(1);
 }
 
}


int InitSocketServeurMessage(Sem_et_int ind) {
/** Description : Permet de cre un socket pour communiquer les messages. */
/** Valeur de retour : 
	0 = ok
	-1 = pb
*/ 
/** detail de la fonction :  */
     
    bzero(&ind.mon_address,sizeof(ind.mon_address));
    ind.mon_address.sin_port = htons(2005);
    ind.mon_address.sin_family = AF_INET;
    ind.mon_address.sin_addr.s_addr = htonl(INADDR_ANY);
/** creation de socket */
   if ((ma_socketMessage = socket(AF_INET,SOCK_STREAM,0))== -1){
      printf("pb avec la creation\n");
      return(-1); 
   }
   signal(SIGINT,finPrg);
/** bind serveur - socket */
   bind(ma_socketMessage,(struct sockaddr *)&ind.mon_address,sizeof(ind.mon_address));

/** ecoute sur la socket */
   listen(ma_socketMessage,5);
   

/** accept la connexion */
   ind.mon_address_longueur = sizeof(ind.client_address);
   return(ma_socketMessage);
}


int InitSocketServeur(Sem_et_int ind) {
/** Description : Permet de cre un socket pour communiquer les messages. */
/** Valeur de retour : 
	0 = ok
	-1 = pb
*/ 
/** detail de la fonction :  */
     
    bzero(&ind.mon_address,sizeof(ind.mon_address));
    ind.mon_address.sin_port = htons(2004);
    ind.mon_address.sin_family = AF_INET;
    ind.mon_address.sin_addr.s_addr = htonl(INADDR_ANY);
/** creation de socket */
   if ((ma_socket = socket(AF_INET,SOCK_STREAM,0))== -1){
      printf("pb avec la creation\n");
      return(-1);
   }
   signal(SIGINT,finPrg);
/** bind serveur - socket */
   bind(ma_socket,(struct sockaddr *)&ind.mon_address,sizeof(ind.mon_address));

/** ecoute sur la socket */
   listen(ma_socket,5);
   

/** accept la connexion */
   ind.mon_address_longueur = sizeof(ind.client_address);
   return(ma_socket);
}

void *threadGPIO(void *pointStruc)
/** Description : lance le process de lecture des entree du GPIO */
/** variable delaysleepGPIO = temps entre chaque lecture */
/** observation : Probleme a finir (write dans le registre le resultat */
/** detail de la fonction :  */
{
Sem_et_int *point;
point = (Sem_et_int *) pointStruc;


unsigned int val,val2,val3;
int cpt,cpt2;
int compteur=0;

sleep(5);
/** -> boucle infini tant que variable globale !=2*/      
while(globale != 2) { 
/** -> Lecture des GPIO 
      cPCI_GPIO_Status_Read()
      cPCI_GPIO_Update_Read()
      cPCI_GPIO_Report_Read()
*/
     // printf("%3d : read GPIO value\n",compteur);
      cPCI_GPIO_Status_Read(file_desc,(int*)&val);  // lecture direction in/out 
      cPCI_GPIO_Update_Read(file_desc,(int*)&val3); // lectre des valuer actuelle de sortie
      cPCI_GPIO_Report_Read(file_desc,(int*)&val2); // lecture des valeurs d'entres
      for(cpt=0; cpt<NB_GPIO; cpt++) {
         if(!(val &(1<<cpt))) {
            ValueOutGPIO[cpt]=(val3&(1<<cpt))>>cpt;
            //printf("output %s = %d out=%u\n",descriptionGPIO[cpt],directionGPIO[cpt],ValueOutGPIO[cpt]);    
         }
      }    
 
/* -> si le Mode automatique est validee autoMod bit 3 = 1*/
/* -> Alors on test les entrees et en fonction des tableaux 
maskInOutGPOLocateTable1[]
seuilInOutGPOLocateTable1[]
maskInOutGPOLocateTable0[]	  
seuilInOutGPOLocateTable0[]*/
/* -> on va actionner les sorties */
	  if(((autoMod&4)>2)==1) { // auto mod ON OFF pour actionner les sortie en fonction des entres
        for(cpt=0; cpt<NB_GPIO; cpt++) { // scrute toute les GPIO
         if(val &(1<<cpt)) {          // regarde si cette GPIO est un entree
          if(ValueInGPIO[cpt]!=(val2&(1<<cpt))>>cpt) { // regarde si cette GPIO a change            if(val2&(1<<cpt))>>cpt==1) {                                    
             if((val2&(1<<cpt))>>cpt==1) {  // regare la valeur du bit (ici 1)                                          
                 for(cpt2=0; cpt2<NB_GPIO; cpt2++) { // pour toute la table                  
                     if(((maskInOutGPOLocateTable1[cpt] &(1<<cpt2))>>cpt2) ==1) { // regarde si pour cette sortie mask
                       if(((seuilInOutGPOLocateTable1[cpt] &(1<<cpt2))>>cpt2) ==1) val3 |= (1<<cpt2); // affecte a 1 cpt2
                       else  val3 &= ~(1<<cpt2);  // affecte a 0 la sortie GPIO cpt2
                     }
                 }
             }
             if((val2&(1<<cpt))>>cpt==0) { // regarde la valeur du bit (ici 0)  
                 for(cpt2=0; cpt2<NB_GPIO; cpt2++) {  // pour toute la table                       
                     if(((maskInOutGPOLocateTable0[cpt] &(1<<cpt2))>>cpt2) ==1) { // regarde si pour cette sortie mask
                       if(((seuilInOutGPOLocateTable0[cpt] &(1<<cpt2))>>cpt2) ==1) val3 |= (1<<cpt2);// affecte a 1 cpt2
                       else  val3 &= ~(1<<cpt2);  // affecte a 0 la sortie GPIO cpt2                  
                     }
                 }
             }
          }
         }
        }    
      }   
      
      /**  -> Avertir le client via des sockets le changement d'un bit des GPIO d'entree */
      for(cpt=0; cpt<NB_GPIO; cpt++) {
          if(val &(1<<cpt)) {
            if(ValueInGPIO[cpt]!=(val2&(1<<cpt))>>cpt) {
               ValueInGPIO[cpt]=(val2&(1<<cpt))>>cpt;
               sprintf(alerteMessage,"%s Input I/O change : %s = %u\n",levelMessageGPIO, descriptionGPIO[cpt],ValueInGPIO[cpt]);    
               write(client_socketMessage,alerteMessage, SIZE_BUFFER);                                                                                            
            }
          } 
      }                  
      compteur++;                
      usleep(DELAY_SLEEP_GPIO*10000);
}
return NULL;
}



void *threadPhotodiode(void *pointStruc){
/** Description : lance le process de lecture des photodiodes */
/** variable delaysleepPhotodiode = temps entre chaque lecture */
/** detail de la fonction :  */
Sem_et_int *point;
point = (Sem_et_int *) pointStruc;



int valeur;
int flagTemp=0;
int cpt,cpt2;
int cptMoy[NB_PHOTODIODE];
int compteur=0;

sleep(5);
/** -> boucle infini tant que variable globale !=2*/      
while(globale != 2) { 
     // printf("%3d : read photodiode value\n",compteur);
      for(cpt=0; cpt<NB_PHOTODIODE; cpt++) {
/** -> lecture de toutes les photodiodes NB_PHOTODIODE
		   cPCI_Photodiode_Ctrl_Write()
           cPCI_Photodiode_Ctrl_Write()
           cPCI_Photodiode_Ctrl_Write()
           cPCI_Photodiode_Value_Read()
*/
         if(photodiodeOnOff &(1<<cpt)) {
           flagTemp=0;
           cPCI_Photodiode_Ctrl_Write(file_desc, (cpt<<4)+0);
           usleep(100);
           cPCI_Photodiode_Ctrl_Write(file_desc, (cpt<<4)+1);
           usleep(100);
           cPCI_Photodiode_Ctrl_Write(file_desc, (cpt<<4)+0);
           cPCI_Photodiode_Value_Read(file_desc,&valeur);
           usleep(100);
           
/** -> si resultat > seuil (seuilPhotodiodeIncrease[]) */
           if(valeur>seuilPhotodiodeIncrease[etatPhotoDiode[cpt]]) { 
/** .          -> regarde si etat maximum n'est pas atteint nbSeuilPhotodiode*/                  
              if(etatPhotoDiode[cpt]<nbSeuilPhotodiode) {
/** .              -> prepare une alerte et augmente l'etat de cette photodiode : etatPhotoDiode[]*/                  
			     flagTemp= 1;
                 etatPhotoDiode[cpt]++;
                 sprintf(alerteMessage,"%s photodiode : [photodiode] %d : photodiode = %x seuil %d atteint \n\0",levelMessagePhotodiode[etatPhotoDiode[cpt]-1],cpt,valeur,etatPhotoDiode[cpt]);       
                 printf("%s\n",alerteMessage);
              }
           }
/** .        -> regarde si etat mamimal n'est pas atteint 0*/                  
		   if(etatPhotoDiode[cpt]>0) { 
/** .          -> si le resultat est en dessous du seuil de lumiere  rangee dans seuilPhotodiodeDecrease[]*/
                if(valeur<seuilPhotodiodeDecrease[etatPhotoDiode[cpt]-1]) {                                                                   
/** .              -> prepare une alerte et diminue l'etat de cette photodiode etatPhotoDiode[]*/                  
					flagTemp= 1;
                    etatPhotoDiode[cpt]--;
                    sprintf(alerteMessage,"Alerte photodiode : [photodiode] %d : photodiode = %x seuil %d atteint \n\0",cpt,valeur,etatPhotoDiode[cpt]);       
                    printf("%s\n",alerteMessage);
                 }
           }
/** . -> si changement d'etat pour cette photodiode on envoi un message au client*/                             
		   if(flagTemp && (client_socketMessage!=-1)) write(client_socketMessage,alerteMessage, SIZE_BUFFER);
           }
      } 
      compteur++;                
      usleep(DELAY_SLEEP_PHOTODIODE*10000);
}
return NULL;
}


void *threadFan(void *pointStruc){
/** Description : lance le process de lecture des vitesses des ventillateurs */
/** variable delaysleepFan = temps entre chaque lecture */
/** detail de la fonction :  */
Sem_et_int *point;
point = (Sem_et_int *) pointStruc;

unsigned int val;
int          cpt;
int          compteur=0;

sleep(5);
/** -> boucle infini tant que variable globale !=2*/      
while(globale != 2) { 
     // printf("%3d : read Fan value\n",compteur);
/** -> Lecture des registres de ventillateurs 
	  cPCI_Zone_Fan_DAC_Register_Read()
	  cPCI_Fan_Status_Read();
	  */      
      for(cpt=0; cpt<NB_FAN; cpt++) { 
          if((autoMod&1)==1) cPCI_Zone_Fan_DAC_Register_Write(file_desc, cpt, calculFan[cpt]);       
          cPCI_Zone_Fan_DAC_Register_Read(file_desc, cpt);
          cPCI_Fan_Status_Read(file_desc,(int *)&val);
          valeurLuFan[cpt] = val;
      } 
      compteur++;                
      usleep(DELAY_SLEEP_FAN*10000);
}
return NULL;
}


void *threadTemperature(void *pointStruc){
/** Description : lance le process de monitoring et controle des temperatures */
/** variable delaysleepTemperature = temps entre chaque lecture */
/** detail de la fonction :  */

Sem_et_int *point;
point = (Sem_et_int *) pointStruc;

float valeur;
unsigned int val,val2,val3;
int   qui;
int   cpt,cpt2;//,cpt3;
char  buffer[255];
int   flagTemp=0;
int   compteur=0;
int   cptMoy[NB_SENSOR];
char chaine_temp[255];


/**  -> init temp ctrl register  cPCI_Temp_Ctrl_Read() cPCI_Temp_Ctrl_Write()*/
  cPCI_Temp_Ctrl_Read(file_desc);
  cPCI_Temp_Ctrl_Write(file_desc,0x7f2);

/** -> boucle infini tant que variable globale !=2*/
  while(globale != 2) { 

     if((client_socket >0)&&(client_socketMessage==-1)) {
	client_socketMessage = accept(ma_socketMessage,(struct sockaddr *)&(*point).client_address,&(*point).mon_address_longueur); 
	printf("ici client_socketMessage =%d\n",client_socketMessage);
     }

     // printf("%3d : read temperature sensor\n",compteur);                     
      buffer[0]='\0';
/** .   -> pour les 32 sondes de temperatures NB_SENSOR */
      for(cpt=0; cpt<NB_SENSOR; cpt++) {
/** .       -> si la sonde est validee*/
         if(tempOnOff &(1<<cpt)) {
             flagTemp=0;
/** .       -> lecture du registre temperature 
	     cPCI_Temp_MUX_Write() cPCI_Temp_MUX_Read() cPCI_Temp_MUX_VALUE_Read() */
             cPCI_Temp_MUX_Write(file_desc, cpt);
             usleep(100);
             qui = cPCI_Temp_MUX_Read(file_desc);
             usleep(100);
             cPCI_Temp_MUX_VALUE_Read(file_desc,&valeur);
             usleep(100);
/** .       -> rangement du resultat dans le tableau moyTemp[] et recalcul de la moyenne */ 
             if(cptMoy[cpt]<tempNbMoy) {
                  moyTemp[cpt][cptMoy[cpt]]=valeur;
                  cptMoy[cpt]++;
             } else {
                  cptMoy[cpt]=0;
             }
             valeur=0;
             for(cpt2=0; cpt2<tempNbMoy; cpt2++) {
                valeur+= moyTemp[cpt][cpt2];
             }
             valeur /= tempNbMoy;
             valeurMoyTemp[cpt] = valeur;
/** .       -> si le resultat depasse le seuil de temperature rangee dans seuilTemp[]*/
             if(valeur>seuilTemp[etat[cpt]]) { 
/** .          -> regarde si etat maximum n'est pas atteint nbSeuilTemp*/                  
				  if(etat[cpt]<nbSeuilTemp) {
/** .              -> prepare une alerte et augmente l'etat de cette sonde*/                  
					 flagTemp= 1;
                     etat[cpt]++;
                     sprintf(alerteMessage,"%s temp : [sonde] %d : Temp = %f seuil %d atteint \n\0",levelMessageTemp[etat[cpt]-1], cpt,valeur,etat[cpt]);       
                     printf("%s\n",alerteMessage);
                  }
             }
/** .        -> regarde si etat mamimal n'est pas atteint 0*/                  
             if(etat[cpt]>0) { 
/** .          -> si le resultat est en dessous du seuil de temperature rangee dans seuilTempDecrease[]*/
                 if(valeur<seuilTempDecrease[etat[cpt]-1]) {                                                                   
/** .              -> prepare une alerte et diminue l'etat de cette sonde*/                  
                      flagTemp= 1;
                      etat[cpt]--;
                      sprintf(alerteMessage,"Caution temp : [sonde] %d : Temp = %f seuil %d en diminution \n\0",cpt,valeur,etat[cpt]);                                                                              
                      printf("%s\n",alerteMessage);
                 }
             }
/** .        -> si changement envoi un message au client*/                  
             if(flagTemp && (client_socketMessage!=-1)) write(client_socketMessage,alerteMessage, SIZE_BUFFER);
         }
	  } 
// modif jlp 07/05/09 affichage des temperatures
	sprintf(chaine_temp,"Sensor ->");
	for(cpt=0; cpt<NB_SENSOR; cpt++) {
               if(tempOnOff&(1<<cpt))      
        		sprintf(chaine_temp,"%s|%4.2f\t\0",chaine_temp,valeurMoyTemp[cpt]);
               else
               		sprintf(chaine_temp,"%s| NO  \t\0",chaine_temp);
	}
	printf("%s\n",chaine_temp);
// fin de modif


/** . -> si changement d'etat pour au moins 1 sonde */                  
	  if(flagTemp) {
/** .      -> alors on recalcul la vitesse des ventillateurs*/                  

		  for(cpt2=0; cpt2<NB_FAN; cpt2++)  calculFan[cpt2]=0;
		  for(cpt=0; cpt<NB_SENSOR; cpt++) {
			if(tempOnOff &(1<<cpt)) {               
		           for(cpt2=0; cpt2<NB_FAN; cpt2++) {  
 	                           if(fanOutOnOff &(1<<cpt)) {
					// modif jlp le 07/05/09 chanegement calcul de la vitesse des fans
					// ancien calcul = somme des vitesses pour chaque sonde
					// nouveau calcul = maximum des vitesses des sondes 
					//calculFan[cpt2] += tempFanTable[cpt][etat[cpt]-1][cpt2];

					if(calculFan[cpt2] < tempFanTable[cpt][etat[cpt]-1][cpt2])
						calculFan[cpt2] = tempFanTable[cpt][etat[cpt]-1][cpt2];	 
					//printf("cpt=%d cpt2=%d etat[%d]=%d tempFanTable[cpt][etat[cpt]][cpt2]=%d calculFan[%d]=%d\n",cpt,cpt2,cpt,etat[cpt]-1,tempFanTable[cpt][etat[cpt]-1][cpt2],cpt2,calculFan[cpt2]);           
					// fin modif
				   }
        	                   if(calculFan[cpt2]>255) calculFan[cpt2]=255; 
                   	   }
			}
		  }
/** .      -> on calcul l'etat max de toutes les sondes*/
		  int maxSeuil=0;// important
		  for( cpt=0; cpt<NB_SENSOR; cpt++) { 
			  if(etat[cpt] >maxSeuil) maxSeuil= etat[cpt] ;
          }
/** .      -> si le mode automatique des ventillateurs est activee autoMod bit 0=1*/
		  if((autoMod&1)==1) {
			  sprintf(alerteMessage,"Caution CalculFan= ");
/** .         -> on change la vitesse des ventillateurs avec calculFan[]
			  cPCI_Zone_Fan_DAC_Register_Write();       
			  cPCI_Zone_Fan_DAC_Register_Read();
		      cPCI_Fan_Status_Read() */
			  for(cpt=0; cpt<NB_FAN; cpt++) { 
				  sprintf(alerteMessage,"%s%x ",alerteMessage,calculFan[cpt]);
				  cPCI_Zone_Fan_DAC_Register_Write(file_desc, cpt, calculFan[cpt]);       
				  cPCI_Zone_Fan_DAC_Register_Read(file_desc, cpt);
				  cPCI_Fan_Status_Read(file_desc,(int *)&val);
				  valeurLuFan[cpt] = val;
				// modif jlp le 07/05/09 pour limiter l'appel de courant dans l'alimentation
				// on va faire une pause dans la commande afin de limiter l'appel 
				if(!(cpt%4)) { // ici on fait le modulo pour couper la commande en x parties
					usleep(DELAY_SLEEP_FAN*10000);
				}	
              		  }  
			  sprintf(alerteMessage,"%s\n",alerteMessage);
			  if(client_socketMessage!=-1) write(client_socketMessage,alerteMessage, SIZE_BUFFER);
		  } // end of autoMod

/** .      -> si le mode automatique des GPIO est activee autoMod bit 1=1*/
                  if(((autoMod&2)>1)==1) {
/** .         -> on change les GPIO en fonction maskGPOLocateTable seuilGPOLocateTable 
					  cPCI_GPIO_Update_Read() 
					  cPCI_GPIO_Update_Write() */
                     if(etatMax != maxSeuil) {
                        etatMax=maxSeuil;
                        printf("%s Seuil %d GPIO maskGPOLocateTable=%x seuilGPOLocateTable=%x\n",levelMessageTemp[maxSeuil-1], maxSeuil,maskGPOLocateTable[maxSeuil-1],seuilGPOLocateTable[maxSeuil-1]);
                        cPCI_GPIO_Update_Read(file_desc,(int *)&val2);
                        for(cpt=0,val3=0; cpt<NB_GPIO; cpt++) {     
                           if(maskGPOLocateTable[maxSeuil-1]&(1<<cpt)){
							   if(seuilGPOLocateTable[maxSeuil-1]&(1<<cpt)) val |= (1 << cpt); 
                               else  val &= ~(1 << cpt);
                           }
                           else {
                               if(val2 &(1<<cpt))   val |= (1 << cpt);
                               else   val &= ~(1 << cpt);                              
                           }
                        }
                        if(val != val2) {
                               printf("il faut mettre  %x \n",val);
                               cPCI_GPIO_Update_Write(file_desc,val);
                               sprintf(alerteMessage,"Caution NEW GPIO action = %x",val);
                               sprintf(alerteMessage,"%s\n",alerteMessage);
                               if(client_socketMessage!=-1) write(client_socketMessage,alerteMessage, SIZE_BUFFER);
                        }
                     }
                  }    // end of autoMod           
	  } // end of flagTemp                                           
	  compteur++;
	  usleep(DELAY_TEMPERATURE*10000);

}
return NULL;
}


void *fils(void *pointStruc){
/** Description : lance le process de lecture des ordres du client (vi socket) */
/** detail de la fonction :  */

 int        sval;
 Sem_et_int *point;
 int        fin_a=1;
 int        fin_b=1;

 point = (Sem_et_int *) pointStruc;
 
 /** -> boucle while tant fin_a <>0 */
 while(fin_a) {
	listen(ma_socket,5);
    client_socket=-1;
 /** -->  attend un ordre du client via socket (ma_socket); */
    while(client_socket ==-1) {
       client_socket = accept(ma_socket,(struct sockaddr *)&(*point).client_address,&(*point).mon_address_longueur); 
       printf("ici client_socket =%d\n",client_socket);
       sleep(2);
    }
    printf("client_socket =%d\n",client_socket);
    fin_b=1;
	/** ---> traite le contenu de l'ordre */ 
    while(fin_b>0) {
		fin_b=appli(client_socket);
        sem_getvalue((*point).sem, &sval);
        printf("appli sval=%d\n",sval); 
    }
      
    printf("fin_b =%d\n",fin_b);
    sleep(2);  
    if(fin_b == -1) fin_a=0;   
    shutdown(client_socket,2);     
    printf("Le client s'en va\n");
    printf("et je continue\n");
}

int locale = globale;
sleep(1);
locale += (*point).valAdd;
globale = locale;

return NULL;
}



int appli(int no_client_socket){
/** Description :  lit puis traite l'ordre du client (socket)*/
/** Retour de la foncton */
/** -> -1 = erreur sur la lecture de la socket */
/** -> 0  = ok fin de la lecture et traitement de l'ordre */
/** detail de la fonction :  */

   int lg;
   char buffer[SIZE_BUFFER];

   /** -> lecture de l'ordre du client sur la socket */
   lg = read(no_client_socket,buffer, SIZE_BUFFER);
   if(lg == -1) fin=-1;
   if(lg >0) {        
      printf("le serveur a recu: %s %d\n",buffer,lg);
      int find=0;
      int debut =0;
	  /** --> traitement l'ordre ou des ordres lues sur la socket  
	   parse2() */
      do { 
             find = parse2(buffer,debut);
             debut += find;
      } while( find !=0);
   }    
  return (fin);
}
